- Main Page
- Classes
- Files
- Related Pages

- Search for |

- Alphabetical List
- Class List
- Class Hierarchy
- Class Members

# TAO_SCIOP_Profile Class Reference

This class defines the protocol specific attributes required for locating ORBs over a TCP/IP network. More...

`#include <SCIOP_Profile.h>`

Inheritance diagram for TAO_SCIOP_Profile:

[legend]
Collaboration diagram for TAO_SCIOP_Profile:

[legend]
List of all members.

## Public Member Functions
virtual char | object_key_delimiter (void) const
| TAO_SCIOP_Profile (const ACE_INET_Addr &addr, const TAO::ObjectKey &object_key, const TAO_GIOP_Message_Version &version, TAO_ORB_Core *orb_core)
| TAO_SCIOP_Profile (const char *host, CORBA::UShort port, const TAO::ObjectKey &object_key, const ACE_INET_Addr &addr, const TAO_GIOP_Message_Version &version, TAO_ORB_Core *orb_core)
| TAO_SCIOP_Profile (TAO_ORB_Core *orb_core)
| Profile constructor, default.
| ~TAO_SCIOP_Profile (void)
| Destructor is to be called only through <_decr_refcnt>.
virtual char * | to_string ()
| Template methods. Please see Profile.h for documentation.
virtual int | encode_endpoints (void)
virtual TAO_Endpoint * | endpoint (void)
virtual CORBA::ULong | endpoint_count (void) const
virtual CORBA::ULong | hash (CORBA::ULong max)
void | add_endpoint (TAO_SCIOP_Endpoint *endp)
## Static Public Member Functions
static const char * | prefix (void)
| Return the char string prefix.
## Static Public Attributes
static const char | object_key_delimiter_ = '/'
| The object key delimiter that SCIOP uses or expects.
## Protected Member Functions
virtual int | decode_profile (TAO_InputCDR &cdr)
| Template methods. Please see Profile.h for the documentation.
virtual int | decode_endpoints (void)
virtual void | parse_string_i (const char *string)
virtual void | create_profile_body (TAO_OutputCDR &cdr) const
virtual CORBA::Boolean | do_is_equivalent (const TAO_Profile *other_profile)
## Protected Attributes
TAO_SCIOP_Endpoint | endpoint_
CORBA::ULong | count_
| Number of endpoints in the list headed by <endpoint_>.

## Detailed Description

This class defines the protocol specific attributes required for locating ORBs over a TCP/IP network.

This class defines the SCIOP profile as specified in the CORBA specification.

## Constructor & Destructor Documentation

TAO_SCIOP_Profile::TAO_SCIOP_Profile | ( | const ACE_INET_Addr & | addr,
|  | const TAO::ObjectKey & | object_key,
|  | const TAO_GIOP_Message_Version & | version,
|  | TAO_ORB_Core * | orb_core |
| ) |  |  |

Profile constructor, same as above except the object_key has already been marshaled.

TAO_SCIOP_Profile::TAO_SCIOP_Profile | ( | const char * | host,
|  | CORBA::UShort | port,
|  | const TAO::ObjectKey & | object_key,
|  | const ACE_INET_Addr & | addr,
|  | const TAO_GIOP_Message_Version & | version,
|  | TAO_ORB_Core * | orb_core |
| ) |  |  |

Profile constructor, this is the most efficient since it doesn't require any address resolution processing.

TAO_SCIOP_Profile::TAO_SCIOP_Profile | ( | TAO_ORB_Core * | orb_core | ) |

Profile constructor, default.

TAO_SCIOP_Profile::~TAO_SCIOP_Profile | ( | void |  | ) |

Destructor is to be called only through <_decr_refcnt>.

## Member Function Documentation

void TAO_SCIOP_Profile::add_endpoint | ( | TAO_SCIOP_Endpoint * | endp | ) |

Add <endp> to this profile's list of endpoints (it is inserted next to the head of the list). This profiles takes ownership of <endp>.

void TAO_SCIOP_Profile::create_profile_body | ( | TAO_OutputCDR & | cdr | ) | const`[protected, virtual]`

Implements TAO_Profile.

int TAO_SCIOP_Profile::decode_endpoints | ( | void |  | ) | `[protected, virtual]`

Implements TAO_Profile.

int TAO_SCIOP_Profile::decode_profile | ( | TAO_InputCDR & | cdr | ) | `[protected, virtual]`

Template methods. Please see Profile.h for the documentation.

Implements TAO_Profile.

CORBA::Boolean TAO_SCIOP_Profile::do_is_equivalent | ( | const TAO_Profile * | other_profile | ) | `[protected, virtual]`

Implements TAO_Profile.

int TAO_SCIOP_Profile::encode_endpoints | ( | void |  | ) | `[virtual]`

Implements TAO_Profile.

TAO_Endpoint * TAO_SCIOP_Profile::endpoint | ( | void |  | ) | `[virtual]`

Implements TAO_Profile.

CORBA::ULong TAO_SCIOP_Profile::endpoint_count | ( | void |  | ) | const`[virtual]`

Implements TAO_Profile.

CORBA::ULong TAO_SCIOP_Profile::hash | ( | CORBA::ULong | max | ) | `[virtual]`

Implements TAO_Profile.

TAO_BEGIN_VERSIONED_NAMESPACE_DECL char TAO_SCIOP_Profile::object_key_delimiter | ( | void |  | ) | const`[virtual]`

Implements TAO_Profile.

void TAO_SCIOP_Profile::parse_string_i | ( | const char * | string | ) | `[protected, virtual]`

Implements TAO_Profile.

const char * TAO_SCIOP_Profile::prefix | ( | void |  | ) | `[static]`

Return the char string prefix.

char * TAO_SCIOP_Profile::to_string | ( |  | ) | `[virtual]`

Template methods. Please see Profile.h for documentation.

Implements TAO_Profile.

## Member Data Documentation

CORBA::ULong TAO_SCIOP_Profile::count_`[protected]`

Number of endpoints in the list headed by <endpoint_>.

TAO_SCIOP_Endpoint TAO_SCIOP_Profile::endpoint_`[protected]`

Head of this profile's list of endpoints. This endpoint is not dynamically allocated because a profile always contains at least one endpoint.

Currently, a profile contains more than one endpoint, i.e., list contains more than just the head, only for two cases (1) when RTCORBA is enabled and (2) the ORB is initialized with -ORBPreferredInterfaces option. However, in the near future, this will be used in for mode as well, e.g., to support TAG_ALTERNATE_IIOP_ADDRESS feature.

This is probably as good a place to discuss how the list of endpoints is used for #2. If the ORB is configured to use preferred interfaces for invocation, TAO creates an endpoint per preferred interface. To be clear, every tuple <destination:target> will have an endpoint. What TAO essentially does is that creates it multiple endpoints so that the invocation code path can use existing iterating techniques to try one preferred interface after another (if the first did not work). If the ORB is configured with -ORBEnforcePreferredInterface set to false in addition to the ORBPreferredInterfaces option , TAO creates another endpoint with the preferred bit set to null, so that the invocation code can fall back to a SCTP stack returned local address. Addressing info of the default endpoint, i.e., head of the list, is transmitted using standard SCIOP ProfileBody components. See <encode_endpoints> method documentation above for how the rest of the endpoint list is transmitted.

const char TAO_SCIOP_Profile::object_key_delimiter_ = '/'`[static]`

The object key delimiter that SCIOP uses or expects.

The documentation for this class was generated from the following files:

- SCIOP_Profile.h
- SCIOP_Profile.cpp